
#import "AlignPaletteWinCtl.h"

#import "CoverWinCtl.h"
#import "CoverView.h"

@implementation AlignPaletteWinCtl
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
+ ( id ) 
sharedAlignPaletteWinCtrl 
{
	static	AlignPaletteWinCtl	* locSharedWinCtrl  = nil ;
	
	if ( ! locSharedWinCtrl )
	{
		locSharedWinCtrl = [[ AlignPaletteWinCtl allocWithZone: [self zone]] init ] ;
	}
	return ( locSharedWinCtrl );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// inizializzo la finestra caricandola dal file nib
- (id )
init 
{
	self = [ self initWithWindowNibName: @"AlignPalette" ];
	theDrawView = nil;
	return ( self );
}

- (void)windowDidLoad 
{
    [super windowDidLoad];
	// aggiungo due osservatori quando cambia la finestra principale
	// in modo che possa aggiustare theDrawView
    [[NSNotificationCenter defaultCenter] addObserver:self 
		selector:@selector(mainWindowChanged:) 
		name:NSWindowDidBecomeMainNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self 
		selector:@selector(mainWindowResigned:) 
		name:NSWindowDidResignMainNotification object:nil];
	// pero' devo mettere a posto la prima volta 
	// recupero la finestra di fronte a tutti
	[self setMainWindow:[NSApp mainWindow]];
}

// --------------------------------------------------------------------- 
- (void)
mainWindowChanged: (NSNotification *)notification 
{
    [self setMainWindow:[notification object]];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
mainWindowResigned: (NSNotification *)notification 
{
    [self setMainWindow:nil];
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
setMainWindow: (NSWindow *) mainWindow 
{
    NSWindowController *controller = [mainWindow windowController];
	// se c'e' una finestra ed e' del tipo giusto
    if (controller && [controller isKindOfClass:[CoverWinCtl class]]) 
	{
		theDrawView = [(CoverWinCtl *)controller cvrView];
	}
	else	
	{
		theDrawView = nil;
	}
}

// --------------------------------------------------------------------- 
- (IBAction)executeAlign:(id)sender
{
	// recupero il tag della cella selezionata
	if ( theDrawView )
	{
		int selTag = [[ selectedAlign selectedCell] tag] ;
		if ( selTag == 5 || selTag == 6 )
				[ theDrawView executeCentering: selTag ];
		else	[ theDrawView executeAlignment: selTag ];
	}
}
@end
