// -----------------------------------------------------------------------------
//  CCE_BasicForm.h
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Interface file for the mother of all classes

#import <Foundation/Foundation.h>

@class  CoverView ;

void	ccex_drawHandleAt( NSPoint where, BOOL how );

@interface CCE_BasicForm : NSObject {
	// rettangolo che contiene l'oggetto
    NSRect		elemLimit ;
	// spessore della linea di contorno
	float		cceLineWidth ;
	// colore dell'eventuale interno e del contorno
	NSColor		* cceFillColor ;
	NSColor		* cceLineColor ;
	// se devo colorare l'interno o meno
	BOOL		cceIsFilled ;
	BOOL		cceIsStroked ;
	// se l'elemento e' selezionato o meno
	BOOL		cceIsSelected ;
	// se l'lemento puo' essere manipolato o meno
	BOOL		cceIsLocked ;
	// lista degli handle, sono al massimo otto
	int			numOfHdl ;
	NSPoint		hdlList[8] ;
}
// metodi che ogni sottoclasse deve realizzare
// inizializzazione, in qualche forma
- (id) init ;
// deallocazione
- (void) dealloc ;
// disegno dell'elemento
- (void) drawElement: (NSRect) inRect ;
- (BOOL) handleCreation: (NSEvent *)theEvent  inView: (CoverView *)view ;
- (void) buildMeWithStartPt: (NSPoint) stPt andPt: (NSPoint) endPt ;
- (void) buildHdlList ;
- (BOOL) checkClickOnMe:(NSPoint)point ;
- (short) clicIntoHandle: (NSPoint) point ;
- (void) drawHandles ;

- (void) selectMeIfInRect: (NSRect) selRect  addingToSelez: (BOOL) add2sel ;
- (void) moveMeIfSelectBy: (NSPoint) distance ;
- (void) moveMeBy: (NSPoint) distance ;
- (BOOL) handleResize: (NSEvent *)theEvent inView: (CoverView *)view movingHandle: (short) hdlIdx ;

- (NSNumber*) getElemTop ;
- (NSNumber*) getElemLeft ;
- (NSNumber*) getElemRight;
- (NSNumber*) getElemBottom  ;
- (NSNumber*) getElemMiddle ;
- (NSNumber*) getElemCenter ;

// metodi accessor
- (NSRect)elemLimit;
- (void)setElemLimit:(NSRect)newElemLimit;
- (float)cceLineWidth;
- (void)setCceLineWidth:(float)newLineWidth;
- (NSColor *)cceFillColor;
- (void)setCceFillColor:(NSColor *)newFillColor;
- (NSColor *)cceLineColor;
- (void)setCceLineColor:(NSColor *)newLineColor;
- (BOOL)cceIsSelected;
- (void)setCceIsSelected:(BOOL)newIsSelected;
- (BOOL)cceIsFilled;
- (void)setCceIsFilled:(BOOL)newCceIsFilled;
- (BOOL)cceIsStroked;
- (void)setCceIsStroked:(BOOL)newCceIsStroked;
- (BOOL)cceIsLocked;
- (void)setCceIsLocked:(BOOL)newIsSelected;

- (void) printMeWithLevel: (int) lev ;

@end
