// -----------------------------------------------------------------------------
//  CCE_BasicForm.m
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Implementation file for the mother of all classes 

#import "CCE_BasicForm.h"

#import "CoverView.h"

@implementation CCE_BasicForm

// --------------------------------------------------------------------- 
// inizializzazione base di un elemento
- (id) init 
{
	// classica inizializzazione della superclasse
	self = [super init];
    if (self) 
	{
		// inizializzazione delle variabili d'istanza comune
		// il rettangolo rinchiedente e' piccolo piccolo
		numOfHdl = 8 ;
        [self setElemLimit:NSMakeRect(0.0, 0.0, 1.0, 1.0)];
		// colore di riempimento, bianco
        [self setCceFillColor:[NSColor whiteColor]];
		// colore del contorno, nero
        [self setCceLineColor:[NSColor blackColor]];
		// spessore della linea del controno, poco
        [self setCceLineWidth:1.0];
		// non e' normalmente pieno
		cceIsFilled = FALSE ;
		// non e' selezionato ne' bloccato
		cceIsSelected = FALSE ;
		cceIsLocked = FALSE ;
    }
    return self;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// costruzione di un elemento per due punti
- (void)
buildMeWithStartPt: (NSPoint) stPt andPt: (NSPoint) endPt 
{
		float   maxPx = ( stPt.x > endPt.x ) ?  stPt.x : endPt.x ;
		float   maxPy = ( stPt.y > endPt.y ) ?  stPt.y : endPt.y ;
		float   minPx = ( stPt.x < endPt.x ) ?  stPt.x : endPt.x ;
		float   minPy = ( stPt.y < endPt.y ) ?  stPt.y : endPt.y ;
		NSRect  aRect = NSMakeRect( minPx, minPy, maxPx - minPx, maxPy - minPy );
		// metto a posto il rettangolo che lo contiene
		[self setElemLimit: aRect ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// predisposizione dei punti degli handle 
- (void) buildHdlList 
{
		// gli handle sono genericamente ai quattro estremi del
		// rettangolo limite e nei quattro punti mediani
		hdlList[0] = NSMakePoint( elemLimit.origin.x, elemLimit.origin.y) ;
		hdlList[1] = NSMakePoint( elemLimit.origin.x, elemLimit.origin.y+ elemLimit.size.height) ;
		hdlList[2] = NSMakePoint( elemLimit.origin.x + elemLimit.size.width, elemLimit.origin.y+ elemLimit.size.height) ;
		hdlList[3] = NSMakePoint( elemLimit.origin.x + elemLimit.size.width, elemLimit.origin.y) ;
		hdlList[4].x = (hdlList[0].x + hdlList[1].x ) * 0.5 ;
		hdlList[4].y = (hdlList[0].y + hdlList[1].y ) * 0.5 ;
		hdlList[5].x = (hdlList[2].x + hdlList[1].x ) * 0.5 ;
		hdlList[5].y = (hdlList[2].y + hdlList[1].y ) * 0.5 ;
		hdlList[6].x = (hdlList[2].x + hdlList[3].x ) * 0.5 ;
		hdlList[6].y = (hdlList[2].y + hdlList[3].y ) * 0.5 ;
		hdlList[7].x = (hdlList[0].x + hdlList[3].x ) * 0.5 ;
		hdlList[7].y = (hdlList[0].y + hdlList[3].y ) * 0.5 ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void) dealloc 
{
	// distruggo tutto cio' che ho creato
	[ cceLineColor dealloc ];
	[ cceFillColor dealloc ];
    [ super dealloc ];
}

// --------------------------------------------------------------------- 
// metodo per il disegno complessivo
- (void) drawElement: (NSRect) inRect 
{
	// nulla da fare
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// metodo per il disegno degli handle
- (void) drawHandles
{
	if ( cceIsSelected )
	{
		int  i;
		// disegno i manici per la manipolazione
		for ( i = 0 ; i < numOfHdl ; i ++ )
			ccex_drawHandleAt( hdlList[i], cceIsLocked );
	}
}

// --------------------------------------------------------------------- 
// creazione di un elemento tramite mouse
- (BOOL)
handleCreation: (NSEvent *)theEvent 
	inView:		(CoverView *)view 
{
	// recupero la coordinata locale
    NSPoint point1 = [view convertPoint:[theEvent locationInWindow] fromView:nil];
	NSPoint point ;
    BOOL shiftKeyPress ;
	// inizializzo l'aspetto dell'oggetto (praticamente vuoto)
	[ self buildMeWithStartPt: point1 andPt: point1 ] ;
	// continuo a ciclare in attesa di un mouseup
	do  {
		// recupero il prossimo evento, che sia un movimento del mouse 
		// oppure un mouseup (che finisce il tutto)
        theEvent = [[view window] nextEventMatchingMask:(NSLeftMouseDraggedMask | NSLeftMouseUpMask)];  
		shiftKeyPress = (([theEvent modifierFlags] & NSShiftKeyMask) ? YES : NO);
		// recupero la coordinata locale
		point = [view convertPoint:[theEvent locationInWindow] fromView:nil];
		if ( shiftKeyPress ) 
		{				
			// costringo il rettangolo ad essere quadrato
			float   delta1 = ( point.x - point1.x ) ;
			float   delta2 = ( point.y - point1.y ) ;
			float	dirx = 1 ;
			float	diry = 1 ;
			
			if ( delta1 < 0 ) 
			{
				delta1 = - delta1 ; dirx = -1 ;
			}
			if ( delta2 < 0 ) 
			{
				delta2 = - delta2 ; diry = -1 ;
			}
			// piglio la dimensione piu' corta
			if ( delta1 < delta2 ) 
			{
				point.y = point1.y + diry * delta1 ;
			}
			else
			{
				point.x = point1.x + dirx * delta2 ;
			}
		}
		// aggiusto l'aspetto dell'oggetto
		[ self buildMeWithStartPt: point1 andPt: point ] ;
		// forzo un ridisegno della finestra
		[ view setNeedsDisplay: YES ];
    }
	while ( [theEvent type] != NSLeftMouseUp) ;
	// arrivato qui, ho finito il tutto
	return YES;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ridimensionamento di un elemento tramite mouse
- (BOOL)
handleResize: (NSEvent *)theEvent 
	inView:		(CoverView *)view 
	movingHandle: (short) hdlIdx 
{
	// indice dello handle che tengo fisso
	static short fixedHandle[8] =  { 2, 3, 0, 1, 2, 0, 0, 2 };
	// indice dello handle che devo muovere (opposto)
	static short movingHandle[8] = { 0, 1, 2, 3, 0, 2, 2, 0 };
	// identificatore delle coordinate che posso muovere:
	// con 3, x e y; con 2, solo x, con 1 solo y
	static short movingPoints[8] = { 3, 3, 3, 3, 2, 1, 2, 1 };

	short   movingCoord = movingPoints[ hdlIdx ];
	NSPoint fixedPoint = hdlList[ fixedHandle[ hdlIdx ] ];
	NSPoint movingPoint = hdlList[ movingHandle[hdlIdx] ];
	NSPoint point ;
	// se e' locked, non se ne fa nulla
	if ( cceIsLocked ) return YES ;
	// continuo a ciclare in attesa di un mouseup
	do  {
		// recupero il prossimo evento, che sia un movimento del mouse 
		// oppure un mouseup (che finisce il tutto)
        theEvent = [[view window] nextEventMatchingMask:(NSLeftMouseDraggedMask | NSLeftMouseUpMask)];  
		// recupero la coordinata locale
		point = [view convertPoint:[theEvent locationInWindow] fromView:nil];
		// aggiusto l'aspetto dell'oggetto
		switch ( movingCoord ) {
		case 1 :
			[ self buildMeWithStartPt: fixedPoint andPt: NSMakePoint( movingPoint.x, point.y) ] ; 
			break ;			
		case 2 :
			[ self buildMeWithStartPt: fixedPoint andPt: NSMakePoint( point.x, movingPoint.y) ] ; 
			break ;
		case 3 :	// muovo entrambe le coordinate
			[ self buildMeWithStartPt: fixedPoint andPt: point ] ; 
			break ;
		}
		// forzo un ridisegno della finestra
		[ view setNeedsDisplay: YES ];
    }
	while ( [theEvent type] != NSLeftMouseUp) ;
	// arrivato qui, ho finito il tutto
	return YES;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// per sapere se il clic e' sopra l'elemento
- (BOOL) 
checkClickOnMe:(NSPoint)point 
{
	// in generale, controllo se il clik e' avvenuto dentro il rettangolo limite
	return (NSPointInRect(point, [self elemLimit])) ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// per sapere se il clic e' sopra uno degli handle
- (short)
clicIntoHandle: (NSPoint) point
{
	int  i;
	// disegno i manici per la manipolazione
	for ( i = 0 ; i < numOfHdl ; i ++ )
	{
		// se il punto designato e lo handle sono abbastanza vicini
		float   a1 = hdlList[i].x - point.x ;
		float   a2 = hdlList[i].y - point.y ;
		if ( a1 * a1 + a2 * a2 <= 4 )
			return ( i );
	}
	return ( -1 ) ;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// selezione di un elemento attraverso un rettangolo
- (void) 
selectMeIfInRect: (NSRect) selRect addingToSelez: (BOOL) add2sel
{
	NSRect  mioRect = [self elemLimit] ;
	BOOL	inrect = NSContainsRect( selRect, mioRect ) ;
	// se non devo aggiungere alla selezione
	if ( ! add2sel )
	{
		// vince il criterio del rettangolo
		[ self setCceIsSelected: inrect ];
	}
	else
	{
		// qui e' da aggiungere alla selezione
		// se sono dentro il rettangolo
		if ( inrect )
			// per certo lo seleziono
			[ self setCceIsSelected: YES ];
		// altrimenti lascio la selezione precedente
	}
}

// --------------------------------------------------------------------- 
// movimento solo se selezionato
- (void)
moveMeIfSelectBy: (NSPoint) distance
{
	if ( (! cceIsLocked) && cceIsSelected )
	{
		[ self setElemLimit: NSOffsetRect(elemLimit, distance.x, distance.y)];
		[ self buildMeWithStartPt: NSMakePoint(elemLimit.origin.x, elemLimit.origin.y)
				andPt: NSMakePoint( elemLimit.origin.x + elemLimit.size.width, 
									elemLimit.origin.y + elemLimit.size.height) ];
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// movimento senza condizioni
- (void)
moveMeBy: (NSPoint) distance
{
	[ self setElemLimit: NSOffsetRect(elemLimit, distance.x, distance.y)];
	[ self buildMeWithStartPt: NSMakePoint(elemLimit.origin.x, elemLimit.origin.y)
			andPt: NSMakePoint( elemLimit.origin.x + elemLimit.size.width, 
								elemLimit.origin.y + elemLimit.size.height) ];
}

// --------------------------------------------------------------------- 
// per accere comodamente ai limiti dell'elemento
- (NSNumber*) getElemTop 
{
	return ( [ NSNumber numberWithFloat: elemLimit.origin.y] );
}
- (NSNumber*) getElemLeft 
{
	return ( [ NSNumber numberWithFloat: elemLimit.origin.x] );
}

- (NSNumber*) getElemRight
{
	return (  [ NSNumber numberWithFloat: (elemLimit.origin.x + elemLimit.size.width)] );
}

- (NSNumber*) getElemBottom 
{
	return ( [ NSNumber numberWithFloat: (elemLimit.origin.y + elemLimit.size.height)] );
}
- (NSNumber*) getElemMiddle
{
	return ( [ NSNumber numberWithFloat: (elemLimit.origin.y + 0.5 * elemLimit.size.height)] );
}
- (NSNumber*) getElemCenter  
{
	return ( [ NSNumber numberWithFloat: (elemLimit.origin.x + 0.5 * elemLimit.size.width)] );
}

// --------------------------------------------------------------------- 
// metodi accessor
- (NSRect)elemLimit {
    return elemLimit;
}

- (void)setElemLimit:(NSRect)newElemLimit {
        elemLimit = newElemLimit;
		[ self buildHdlList ];
}

- (float)cceLineWidth {
    return cceLineWidth;
}

- (void)setCceLineWidth:(float)newLineWidth {
        cceLineWidth = newLineWidth;
}

- (NSColor *)cceFillColor {
    return cceFillColor ;
}

- (void)setCceFillColor:(NSColor *)newFillColor {
    if (cceFillColor != newFillColor) {
        [cceFillColor release];
        cceFillColor = [newFillColor copy];
    }
}

- (NSColor *)cceLineColor {
    return cceLineColor ;
}

- (void)setCceLineColor:(NSColor *)newLineColor {
    if (cceLineColor != newLineColor) {
        [cceLineColor release];
        cceLineColor = [newLineColor copy];
    }
}

- (BOOL)cceIsSelected {
    return cceIsSelected;
}

- (void)setCceIsSelected:(BOOL)newIsSelected {
	cceIsSelected = newIsSelected;
}

- (BOOL)cceIsLocked {
    return cceIsLocked;
}

- (void)setCceIsLocked:(BOOL)newIsLocked {
        cceIsLocked = newIsLocked;
}

- (BOOL)cceIsFilled {
    return cceIsFilled;
}

- (void)setCceIsFilled:(BOOL)newCceIsFilled {
        cceIsFilled = newCceIsFilled;
}

- (BOOL)cceIsStroked {
    return cceIsStroked;
}

- (void)setCceIsStroked:(BOOL)newCceIsStroked {
        cceIsStroked = newCceIsStroked;
}

// --------------------------------------------------------------------- 
// per avere una stamap delle caratteristiche dell'elemento
- (void)
printMeWithLevel: (int) lev
{
	int i;
	char	blankChar[40];
	NSString	* msg ;
	if ( lev > 10 ) lev = 10 ;
	for ( i = 0; i < lev*4 ; i ++ )
		blankChar[i]= ' ';
	blankChar[lev*4] = 0 ;
	msg = [ NSString stringWithCString: blankChar];
	NSLog( @"%@ -> BasicForm (R: %f %f %f %f)", msg, 
		elemLimit.origin.x, elemLimit.origin.y,
		elemLimit.size.width, elemLimit.size.height );
}
@end

// --------------------------------------------------------------------- 
void	
ccex_drawHandleAt( NSPoint where, BOOL how )
{
	// per ora la dimensione del manico e' fissa 
	int		handleDim = 3 ;
	NSRect	hRect, rRect ;
	// disegno un rettangolo pieno attorno al punto
	hRect = NSMakeRect( where.x, where.y,2*handleDim, 2*handleDim );
	rRect = NSOffsetRect( hRect , -handleDim, -handleDim);
    hRect = NSOffsetRect(rRect, 1.0, 1.0);
	if ( how )
			[[NSColor darkGrayColor] set];
    else	[[NSColor lightGrayColor] set];
    NSRectFill(hRect);
	if ( how )
			[[NSColor lightGrayColor] set];
    else	[[NSColor darkGrayColor] set];
    NSRectFill(rRect);
}
