// -----------------------------------------------------------------------------
//  CCE_Circle.m
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Implementation file for drawing an image

#import "CCE_Circle.h"

#import "CoverView.h"

@implementation CCE_Circle

// --------------------------------------------------------------------- 
// per inizializzare mi serve l'immagine e il punto da dove disegnare
- (id) initWithRect: (NSRect) aRect ;
{
	self = [ super init ];
	if ( self ) 
	{
		// per mia convenienza conservo il percorso
		NSBezierPath *path = [NSBezierPath bezierPathWithOvalInRect: aRect ];
		[ self setTheCircle: path ];
		// metto a posto il rettangolo che lo contiene
		[self setElemLimit: aRect ];
	}
	return ( self );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
buildMeWithStartPt: (NSPoint) stPt andPt: (NSPoint) endPt 
{
		float   maxPx = ( stPt.x > endPt.x ) ?  stPt.x : endPt.x ;
		float   maxPy = ( stPt.y > endPt.y ) ?  stPt.y : endPt.y ;
		float   minPx = ( stPt.x < endPt.x ) ?  stPt.x : endPt.x ;
		float   minPy = ( stPt.y < endPt.y ) ?  stPt.y : endPt.y ;
		NSRect  aRect = NSMakeRect( minPx, minPy, maxPx - minPx, maxPy - minPy );
		// per mia convenienza conservo il percorso
		NSBezierPath *path = [NSBezierPath bezierPathWithOvalInRect: aRect ];
		[ self setTheCircle: path ];
		// metto a posto il rettangolo che lo contiene
		[self setElemLimit: aRect ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// distruggo tutto
-(void) dealloc
{
	[ theCircle release ] ;	
	[ super dealloc ] ;
}

// --------------------------------------------------------------------- 
// il disegno dell'immagine si fa facile
- (void) drawElement: (NSRect) inRect 
{
	if ( cceIsStroked )
	{
		// imposto il colore del contorno
		[ cceLineColor set ];
		// imposto lo spesosre del contorno
		[ theCircle setLineWidth: [ self cceLineWidth ]];
		// disegno il contorno
		[ theCircle stroke ];
	}
	// se il rettangolo e' pieno
	if ( cceIsFilled )
	{
		// imposto il colore del pieno
		[ cceFillColor set ];
		// riempi tutto
		[ theCircle fill ];
	}
	[ self drawHandles ] ;
}

// --------------------------------------------------------------------- 
// vedo se qualcuno ha fatto click su di me
- (BOOL) 
checkClickOnMe:(NSPoint)point 
{
	return ([theCircle containsPoint:point]) ;
}

// --------------------------------------------------------------------- 
// accessor
- (NSBezierPath *)theCircle {
    return theCircle ;
}

- (void)setTheCircle:(NSBezierPath *)newTheCircle {
    if (theCircle != newTheCircle) {
        [theCircle release];
        theCircle = [newTheCircle copy];
    }
}

// --------------------------------------------------------------------- 
- (void)
printMeWithLevel: (int) lev
{
	int i;
	char	blankChar[40];
	NSString	* msg ;
	if ( lev > 10 ) lev = 10 ;
	for ( i = 0; i < lev*4 ; i ++ )
		blankChar[i]= ' ';
	blankChar[lev*4] = 0 ;
	msg = [ NSString stringWithCString: blankChar];
	NSLog( @"%@ -> Circle (R: %7.2f %7.2f S: %7.2f %7.2f) Lw: %6.2f, F: %2d, S: %2d, Sel: %2d, Lk: %2d", msg, 
		elemLimit.origin.x, elemLimit.origin.y,
		elemLimit.size.width, elemLimit.size.height, 
		cceLineWidth, cceIsFilled,cceIsStroked, cceIsSelected, cceIsLocked );
}

@end
