// -----------------------------------------------------------------------------
//  CCE_Text.m
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Implementation file for drawing a string

#import "CCE_Text.h"

@implementation CCE_Text

// --------------------------------------------------------------------- 
// per inizializzare devo aver gia' pronto (e completo!) un NSTextStorage,
// e poi specificare dove disegnare e con che angolo
- (id) initWithTextStorage: (NSTextStorage *) theText 
		atPoint: (NSPoint) aPoint 
		andRotation: (float) angle
{
	self = [ super init ];
	if ( self ) 
	{
		// assegno il textStorage
		[ self setTextStorage: theText ];		
		// e poi gli altri parametri
		drawPoint = aPoint ;
		rotAngle = angle ;
		[ self setElemLimit: NSMakeRect( drawPoint.x, drawPoint.y, 100, 25 )];
	}
	return ( self );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// distruggo tutto
-(void) dealloc
{
	[ textStorage release ] ;	
	[ super dealloc ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// per disegnare il testo, un sacco di lavoro
- (void) drawElement: (NSRect) inRect 
{
	// recupero il primo layout
	NSLayoutManager *layoutManager = [ [ textStorage layoutManagers ] objectAtIndex: 0] ;
	// recupero il primo contenitore
	NSTextContainer *textContainer = [ [ layoutManager textContainers ] objectAtIndex: 0] ;
	// recupero il range del testo
	NSRange glyphRange = [layoutManager glyphRangeForTextContainer: textContainer ];
	// per salvare il contesto
	NSGraphicsContext *context = [NSGraphicsContext currentContext];
	// trasformazione affine per la rototraslazione
	NSAffineTransform *transform = [NSAffineTransform transform];
	// rototraslazione
	[ transform translateXBy:drawPoint.x yBy: drawPoint.y ];
	[ transform rotateByDegrees: rotAngle ];
	[context saveGraphicsState];
	[transform concat];
	// disegno del testo
	[ layoutManager drawGlyphsForGlyphRange:glyphRange atPoint:NSMakePoint(0, 0)];
	[context restoreGraphicsState];
	[ self drawHandles ] ;
}

// --------------------------------------------------------------------- 
// accessor
- (NSTextStorage *)textStorage {
    return [[textStorage retain] autorelease];
}

- (void)setTextStorage:(NSTextStorage *)newTextStorage {
    if (textStorage != newTextStorage) {
        [textStorage release];
        textStorage = [newTextStorage retain];
    }
}

// --------------------------------------------------------------------- 
- (void)
printMeWithLevel: (int) lev
{
	int i;
	char	blankChar[40];
	NSString	* msg ;
	if ( lev > 10 ) lev = 10 ;
	for ( i = 0; i < lev*4 ; i ++ )
		blankChar[i]= ' ';
	blankChar[lev*4] = 0 ;
	msg = [ NSString stringWithCString: blankChar];
	NSLog( @"%@ -> Text", msg );
}

@end
