// -----------------------------------------------------------------------------
//  CatDataSrc.h
//  CdCat2
//
//  Created by Livio Sandel on Mon Dec 29 2003.
//  No Copyright 2003 __MyCompanyName__. 
//
// Interface file for the data source

#import <Foundation/Foundation.h>

#import 	"FileStruct.h"

@class		CdCatDoc ;
@class		CoverWinCtl ;

// per distinguere tra le varie tabelle uso diversi tag
#define		TAG_CDCATDOC_FILELIST		501
#define		TAG_CDCATDOC_FULLLIST		502

@interface CatDataSrc : NSObject {
	// elenco dei volumi
	NSMutableArray	* startPoint ;
	// criterio di ordine
	NSString		* orderColumn ;
	// direzione
	BOOL			orderDirection ;
	// il documento cui fa riferimento
	CdCatDoc		* refDoc ;
	// volume correntemente selezionato
	int				currentVol ;
}
// inizializzazione e disallocazione
- (id)		init ;
- (void)	dealloc ;
// metodo per inserire un file al catalogo
- (void)	addFileEntry: (id) newEntry ;
- (void)	removeEntry: (FileStruct *) newEntry ;

// per la visualizzazione della lista dei volumi
- (int)		numberOfRowsInTableView:(NSTableView *)tv;
- (id)		tableView:(NSTableView *)tv objectValueForTableColumn:(NSTableColumn *)tc row:(int)row;
- (BOOL)	tableView:(NSTableView *)tv shouldEditTableColumn:(NSTableColumn *)tc row:(int)row ;
// metodi delegati
- (void)	tableViewSelectionDidChange:(NSNotification *)aNotification ;

// per la visualizzazione della lista dei file
- (int)	outlineView: (NSOutlineView *) outlineView numberOfChildrenOfItem: (id) item;
- (BOOL)outlineView: (NSOutlineView *) outlineView isItemExpandable: (id) item ;
- (id)	outlineView: (NSOutlineView *) outlineView child: (int) index ofItem: (id) item ;
- (id)	outlineView: (NSOutlineView *) outlineView objectValueForTableColumn: (NSTableColumn *) tableColumn byItem: (id) item;
- (void)outlineView: (NSOutlineView *) outlineView setObjectValue:(id)object forTableColumn:(NSTableColumn *)tableColumn byItem:(id)item ;
// metodi delegati
- (BOOL)outlineView: (NSOutlineView *) oView shouldSelectTableColumn:(NSTableColumn *)tableColumn;
- (BOOL)outlineView: (NSOutlineView *) oView shouldEditTableColumn: (NSTableColumn *) tableColumn item: (id) item ; 
- (void)outlineView: (NSOutlineView *) oView willDisplayCell:(id)aCell forTableColumn:(NSTableColumn *)aTableColumn item:(id)item ;
- (void)outlineViewSelectionDidChange:(NSNotification *)notification ;

- (void) searchFor: (id) item2search column: (NSString*) colId options: (int) opt placeIn: (NSMutableArray*) foundItems ;
- (void) expandDStoItem: (FileStruct*) item inDocument: (CdCatDoc *) currDoc ;

// accessor
- (NSMutableArray *)startPoint;
- (void)setStartPoint:(NSMutableArray *)newStartPoint;
- (NSString *)orderColumn;
- (void)setOrderColumn:(NSString *)newOrderColumn;
- (BOOL)orderDirection;
- (void)setOrderDirection:(BOOL)newOrderDirection;
- (CdCatDoc *)refDoc;
- (void)setRefDoc:(CdCatDoc *)newRefDoc;

@end
