//
//  CdCatDoc.m
//  CdCat2
//
//  Created by Livio Sandel on Sat Dec 27 2003.
//  Copyright (c) 2003 DjZero00Soft. All rights reserved.
//

#import "CdCatDoc.h"

#import "WaitPanCtrl.h"
#import "ChooseVolCtrl.h"
#import "CatDataSrc.h"
#import "VolInfo.h"

@implementation CdCatDoc

// --------------------------------------------------------------------- 
- (id)
init
{
    self = [super init];
    if (self) 
	{
		CatDataSrc		* dataSrc = [[CatDataSrc alloc] init ] ;
		[ dataSrc autorelease ] ;
		// devo costruire l'oggetto sorgente dei dati
		[ self setDataSource: dataSrc ];
		[ dataSource setRefDoc: self ];
		listWin  = nil ;
		coverWin = nil ;
    }
    return self;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void) 
dealloc 
{
	[ dataSource release ];
	[ dataFromFile release ];
	[ super dealloc ] ;
}

// --------------------------------------------------------------------- 
// costruisco il controllore della prima finestra
- (void) 
makeWindowControllers
{
	// istanza del controllore
	listWin = [[ ListWinCtl alloc ] initWithWindowNibName: @"CdListWin" ];
	// autrelease, che tanto poi sara' ritenuta
	[ listWin autorelease ] ;
	// aggiungo la fienstra al documento
	[ self addWindowController: listWin ];
	if ( 1 )
	{
		CoverWinCtl * ctl ;
		ctl = [[ CoverWinCtl alloc ] initWithWindowNibName: @"CoversWin" ];
		[ ctl autorelease ] ;
		[ self addWindowController: ctl ];
		[[ ctl window ] makeKeyAndOrderFront: self ];
		[ self setCoverWin: ctl ];
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void) 
windowControllerDidLoadNib: (NSWindowController *) aController
{
	// invoco il metodo della super-classe
	[super windowControllerDidLoadNib:aController];
	// carico i dati nella finestra
	[ self loadCatalogWithData: dataFromFile] ;
}

// --------------------------------------------------------------------- 
// metodi per salvataggio / rispristino del contenuto del documento
- (NSData *)
dataRepresentationOfType: (NSString *)aType
{
	return ( [NSArchiver archivedDataWithRootObject: [dataSource startPoint] ] );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (BOOL)
loadDataRepresentation: (NSData *)data 
	ofType: (NSString *)aType
{
	// se c'e' almeno una finestra
	if ( [ self windowControllers ] )
	{
		[ self loadCatalogWithData: data ] ;
	}
	else
	{
		dataFromFile = [ data retain ];
	}
	return ( YES );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
loadCatalogWithData: (NSData *) data
{
	if ( data )
	{
		NSMutableArray * catData = [NSUnarchiver unarchiveObjectWithData: data ];
		// assegno il tutto alla sorgente di dati
		[ dataSource setStartPoint: catData ] ;
	}
	// dico che sono cambiate le cose
	[ self refreshWinsWithListSts: @"" coverSts: @"" ];
}

// --------------------------------------------------------------------- 
// metodi per aggiungere / togliere elementi dal catalogo
- (void)
addVolume2Cat:		(NSWindow *)sheet 
	returnCode:	(int)returnCode 
	contextInfo:	(void  *)contextInfo
{
	NSString	* volName ;

	// se il codice di ritorno e' -1, non ho nulla da fare
	if ( returnCode== -1 )
		return ;
	// se arrivo qui, ho da montare un volume
	// recupero il percorso completo del volume...
	// dalla finestra recupero il il controllore, da qui il vettore dei percorsi, e dal vettore
	// piglio l'elemento di indice returnCode
	volName = [[((ChooseVolCtrl*) [sheet windowController]) volumePaths] objectAtIndex: returnCode ];
	[ self performAddFilesModal: [ NSArray arrayWithObject: volName]];
	// ovviamente, il documento e' stato sporcato
	[ self updateChangeCount: NSChangeDone ] ;
	[ self refreshWinsWithListSts: @"" coverSts: @"" ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// aggiunge al catalogo gli elementi nello array
- (void)
performAddFilesModal: ( NSArray *)volList 
{
	NSModalSession 	session ;
	NSEnumerator 	* enumerator = [volList objectEnumerator];
	NSString	* volPath ;
	NSDictionary *fsattrs ; 
	unsigned long long	totalSpace, freeSpace, usedspace ;

	volPath = [enumerator nextObject] ;
	// comincio una sessione modale per l'intera applicazione
	session = [NSApp beginModalSessionForWindow: [ [ WaitPanCtrl sharedProgress] window ] ];
	// eseguo la sessione
	[NSApp runModalSession:session] ;
	// apro la finestra di attesa
	[ WaitPanCtrl showHide: TRUE ];
	[ WaitPanCtrl setModalSession: & session ];
	// finche' ci sono volumi da trattare
	while ( volPath ) 
	{
		// il volPath ho il nome completo del volume
		VolInfo			* fInfo ;
		FSSpec			myFSSpec ;
		FSRef			myFSRef;
		FSVolumeInfo	myInfo; 
		FSCatalogInfo	catinfo ;
		OSStatus		status ;

		// recupero informazioni specifiche di volume
		status = FSPathMakeRef ([volPath fileSystemRepresentation], &myFSRef,  NULL); 
		if (status == noErr)
			status = FSGetCatalogInfo (&myFSRef,  kFSCatInfoNone, & catinfo, NULL,
                                & myFSSpec, NULL);
		// adesso in myFSSpec ho il mio FSSpec
		 status = FSGetVolumeInfo ( myFSSpec.vRefNum, 0, NULL, kFSVolInfoFileCount, 
			& myInfo, NULL, NULL );
		fsattrs = [[NSFileManager defaultManager] fileSystemAttributesAtPath: volPath];
		totalSpace = [[fsattrs objectForKey:NSFileSystemSize] unsignedLongLongValue] ;
		freeSpace = [[fsattrs objectForKey:NSFileSystemFreeSize] unsignedLongLongValue] ;
		usedspace = totalSpace - freeSpace ;
		// aggiorno la finestra di attesa
		[ WaitPanCtrl setMaxValue: myInfo.fileCount ];
		[ WaitPanCtrl setCurrentValue: 0 ];
		[ WaitPanCtrl setText: [NSString stringWithFormat: @"Cataloging: %@", 
			[[ NSFileManager defaultManager] displayNameAtPath: volPath] ]];
		// costruisco l'alberatura dei file a partire dalla scelta
		fInfo = [[ VolInfo alloc ] initTreeFromPath: volPath ];
		// metto a posto le altre informazioni
		[ fInfo setFileSize: usedspace ];
		[ fInfo setVolSize: totalSpace ];
		[ fInfo setVolFreeSize: freeSpace ];
		// aggiungo la cosa al catalogo
		[ dataSource addFileEntry: fInfo ];
		// passo al volume successivo
		volPath = [enumerator nextObject] ;
	}
	// finisco la sessione
	[NSApp endModalSession: session];
	// nascondo la finestra di attesa
	[ WaitPanCtrl setModalSession: nil ];
	[ WaitPanCtrl showHide: FALSE ];
}

// --------------------------------------------------------------------- 
// rinfresco generalizzato di tutte le finestre appartenenti al documento
- (void) 
refreshWinsWithListSts: (NSString*) sts1Bar coverSts: (NSString*) sts2Bar 
{
	// al massimo ci sono due finestre: questa c'e' sicuro
	[ listWin refreshWindow ] ;
	[ listWin setStsStrings: sts1Bar andSts: sts2Bar] ;
	// questa invece vediamo
	if ( coverWin != nil )
	{
		[ coverWin refreshWindow ] ;
		[ coverWin setStsStrings: sts1Bar andSts: sts2Bar] ;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// costruisce, se necessario, la finestra con le copertine
- ( void)
showCoversWindow
{
	// se la finestra delle copertine non c'e'
	if ( coverWin == nil )
	{
		// la costruisco
		CoverWinCtl * ctl ;
		ctl = [[ CoverWinCtl alloc ] initWithWindowNibName: @"CoversWin" ];
		[ ctl autorelease ] ;
		[ self addWindowController: ctl ];
		[[ ctl window ] makeKeyAndOrderFront: self ];
		// attribuisco il valore della variabile
		[ self setCoverWin: ctl ];
	}
}

// --------------------------------------------------------------------- 
// accessor
- (CatDataSrc*)dataSource {
    return [[dataSource retain] autorelease];
}

- (void)setDataSource:(CatDataSrc*)newDataSource {
    if (dataSource != newDataSource) {
        [dataSource release];
        dataSource = [newDataSource retain];
    }
}

- (NSData *)dataFromFile {
    return [[dataFromFile retain] autorelease];
}

- (void)setDataFromFile:(NSData *)newDataFromFile {
    if (dataFromFile != newDataFromFile) {
        [dataFromFile release];
        dataFromFile = [newDataFromFile copy];
    }
}

- (CoverWinCtl *)coverWin {
    return [[coverWin retain] autorelease];
}

- (void)setCoverWin:(CoverWinCtl *)newCoverWin {
    if (coverWin != newCoverWin) {
        [coverWin release];
        coverWin = [newCoverWin retain];
    }
}

@end
