// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  ChooseVolCtrl.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Finestra di scelta di volume

#import <Cocoa/Cocoa.h>

#import		"djZeroUtils.h"

@interface ChooseVolCtrl : NSWindowController
{
	IBOutlet NSTableView *listaVolumi;
	// vettore con i nomi dei volumi
	NSMutableArray 	* volumeNames;
	// vettore con i percorsi dei volumi
	NSMutableArray 	* volumePaths;
	// vettore con le icone dei volumi
	NSMutableArray 	* volumeIcons;
}
// azioni da eseguire quando si seleziona uno dei pulsanti
- (IBAction)cancelButton:(id)sender;
- (IBAction)selectButton:(id)sender;

// per la visualizzazione del contenuto della tabella
- (int) numberOfRowsInTableView:(NSTableView *)tv;
- (id)  tableView:(NSTableView *)tv objectValueForTableColumn:(NSTableColumn *)tc row:(int)row;
- (BOOL)tableView:(NSTableView *)tv shouldEditTableColumn:(NSTableColumn *)tc row:(int)row ;

// metodi usati internamente
- (id )  init ;			// inizializzazione
- (void) dealloc ;		// distruzione
- (void) windowDidLoad ;		// inizializzazione interfaccia
- (void) checkLocalVolumes ;	// recupera la lista dei volumi
// metodo invocato per verificare se e' cambiato qualcosa
- (void ) situationChanged: ( NSNotification *) notification ;

// accessor
- (NSMutableArray *)volumeNames;
- (void)setVolumeNames:(NSMutableArray *)newVolumeNames;
- (NSMutableArray *)volumePaths;
- (void)setVolumePaths:(NSMutableArray *)newVolumePaths;
- (NSMutableArray *)volumeIcons;
- (void)setVolumeIcons:(NSMutableArray *)newVolumeIcons;
@end
