/* CoverView */

#import <Cocoa/Cocoa.h>

#import "CCE_ElemGroup.h"

@class		CoverWinCtl ;

// tentativo: trasformazione pixel - centimetri e viceversa
#define		XFORM_FACTOR		28.346
#define		CM2PX( val )		( val * XFORM_FACTOR)
#define		PX2CM( val )		( val / XFORM_FACTOR)

#define		BACK_OUTER_HOR_DIM		15.1F
#define		BACK_OUTER_VER_DIM		11.8F

#define		BACK_LABEL_HOR_DIM		0.65F
#define		BACK_LABEL_VER_DIM		11.8F

#define		CUTSIGN_DIM				1.0F
#define		CUTSIGN_DIST			0.5F

#define		STARTPOINT_X			1.0F
#define		STARTPOINT_Y			1.0F

#define		VIEW_DIM_HOR	(2*(STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST) + BACK_OUTER_HOR_DIM) 	
#define		VIEW_DIM_VEL	(2*(STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST) + BACK_OUTER_VER_DIM) 	

@interface CoverView : NSView
{
    IBOutlet CoverWinCtl	* winCtl ;
	IBOutlet NSOutlineView  * catView ; 
	// vettore con gli elementi da disegnare
	CCE_ElemGroup		* theElements ;
	// se c'e' un elemento in corso di disegno
	CCE_BasicForm		* curCreatingElem ;
	// rettangolo di selezione
	CCE_Rect			* curSelectRect ;
}

// soliti accessor
- (CoverWinCtl *)winCtl;
- (void)setWinCtl:(CoverWinCtl *)newWinCtl;
- (NSOutlineView *)catView;
- (void)setCatView:(NSOutlineView *)newCatView;
- (CCE_ElemGroup *)theElements;
- (void)setTheElements:(CCE_ElemGroup *)newTheElements;
- (CCE_BasicForm *)curCreatingElem;
- (void)setCurCreatingElem:(CCE_BasicForm *)newCurCreatingElem;
- (CCE_Rect *)curSelectRect;
- (void)setCurSelectRect:(CCE_Rect *)newCurSelectRect;

- (void)keyDown:(NSEvent *)event ;
- (void) handleMoveAll: (NSEvent *)theEvent ;

- (void) mouseDown:(NSEvent *)theEvent ;
- (void) handleMouseClick: (NSEvent *)theEvent ;
- (CCE_BasicForm *) getClickedElem:(NSPoint)point ;
- (NSRect) handleRectSelect: (NSEvent *)theEvent ;

- (void) executeAlignment: (int) menuTag ;
- (void) executeCentering: (int) menuTag ;

- (void) elemAlign: (id)sender ;
- (void) groupElem: (id)sender ;
- (void) lockElems: (id)sender ;
- (void) sendElemFB: (id)sender ;

- (void)setZoom:(float)scaleFactor  ;

@end
