// -----------------------------------------------------------------------------
//  CoverWinCtl.m
//  CdCat2
//
//  Created by Livio Sandel on Mon Dec 29 2003.
//  No Copyright 2003 __MyCompanyName__. 
//
// Implementation file for the window controller

#import		"CoverWinCtl.h"

#import		"ChooseVolCtrl.h"
#import		"ImageAndTextCell.h"
#import		"CatFileInfo.h"
#import		"UserPrefs.h"
#import		"CatDataSrc.h" ;
#import		"CoverView.h" ;
#import		"CdCatDoc.h" ;

#include	<math.h>

NSString* displayZoomFactor( float zf ) ;

@implementation CoverWinCtl

- ( void)
clicBtn01: (id)sender
{
	[cvrView setZoom: 1.0 ];
	[cvrView setNeedsDisplay: YES ];
}

- ( void)
clicBtn02: (id)sender
{
	[ [ cvrView theElements] printMeWithLevel: 0 ];
}

- ( void)
clicBtn03: (id)sender
{

}

- (void) 
setMaxSlider: (id)sender 
{
	[ zoomSlider setFloatValue: [ zoomSlider maxValue]];
	[ self updateZoom: sender];
}
- (void) 
setMinslider: (id)sender
{
	[ zoomSlider setFloatValue: [ zoomSlider minValue]];
	[ self updateZoom: sender];
}

- (void) 
updateZoom: (id)sender
{
	float		czl, rl ;
	czl = [ zoomSlider floatValue ] ;
	if ( czl >= 0 )
			rl = czl + 1;
	else	rl = 1 / (-czl+1) ;
	[cvrView setZoom: rl ];
	[ zoomValue setStringValue: displayZoomFactor(rl) ];
	[cvrView setNeedsDisplay: YES ];
}

// --------------------------------------------------------------------- 
// predisposizione del contenuto della finestra
- (void) windowDidLoad
{
	NSTableColumn		* tableColumn1 = nil;
	NSTableColumn		* tableColumn2 = nil;
	ImageAndTextCell	* imageAndTextCell1 = nil;
	ImageAndTextCell	* imageAndTextCell2 = nil;
	CatDataSrc			* myDataSrc ;
	float				x1, x2, y1, y2 ;
	NSRect				outRect ;
	NSOutlineView		* catView = nil ;
	
	[super windowDidLoad ];
	// associo questa finestra alla sorgente dati
	myDataSrc = [ [self document] dataSource] ;
	[ volList setDelegate:   myDataSrc ];
	[ volList setDataSource: myDataSrc ];
	// salvo nelle prefs le dimensioni delle colonne della outlineView
	[ volList setAutosaveName: @"VolumeViewOptions" ];
	tableColumn1 = [volList tableColumnWithIdentifier: @"volumeList"];
	// creo l'oggetto autorelease perche' passa in carico alla tableColumn
	imageAndTextCell1 = [[[ImageAndTextCell alloc] init] autorelease];
	[imageAndTextCell1 setEditable: NO];
	[tableColumn1 setDataCell:imageAndTextCell1];
	
	// metto a posto la dimensione della view della copertina
    [cvrView setFrameSize:NSMakeSize(CM2PX(VIEW_DIM_HOR), CM2PX(VIEW_DIM_VEL))];

	x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + CUTSIGN_DIM ;
	y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + CUTSIGN_DIM ;
	x2 = BACK_OUTER_HOR_DIM - 2 * CUTSIGN_DIM ;
	y2 = BACK_OUTER_VER_DIM - 2 * CUTSIGN_DIM ;	
	outRect = NSMakeRect(CM2PX(x1), CM2PX(y1), CM2PX(x2), CM2PX(y2)) ;
	catView = [[ NSOutlineView alloc] initWithFrame: outRect ] ;
	[ catView autorelease ];
	// creo la NSTableColumn con l'identificatore
	tableColumn2 = [ [NSTableColumn alloc] initWithIdentifier: COLID_FILENAME ];
	imageAndTextCell2 = [[[ImageAndTextCell alloc] init] autorelease];
	[ tableColumn2 setDataCell:imageAndTextCell2];
	[ tableColumn2 setResizable: TRUE ];
	[ tableColumn2 setWidth: CM2PX(y2)] ;
	// imposto il titolo della colonna
	[ [ tableColumn2 headerCell ] setStringValue: NSLocalizedString( COLID_FILENAME, COLID_FILENAME ) ];
	[ catView addTableColumn: tableColumn2 ];		 
	[ catView setTag: TAG_CDCATDOC_FILELIST ];
	[ catView setDataSource: myDataSrc ];
	[ catView setDelegate: myDataSrc ];
	[ catView setUsesAlternatingRowBackgroundColors: TRUE ];
	[ catView setDrawsGrid: TRUE ];
	[ catView setBackgroundColor: [ NSColor redColor] ];

	[ cvrView setWinCtl: self ];
	[ cvrView setCatView: catView ];
	[ cvrView addSubview: catView ];
	[ zoomValue setStringValue: displayZoomFactor(1.0F) ];	
	[[self window] makeFirstResponder:cvrView];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// il titolo della finestra e' particolarizzato
- (NSString *)
windowTitleForDocumentDisplayName:(NSString *)displayName
{
	return ( [ @"Cover List: " stringByAppendingString: displayName] );
}

// --------------------------------------------------------------------- 
// ricostruzione della outlineView in seguito ad una modifica delle preferenze
- (void)
prefsUpdated: ( NSNotification *) notification
{

}

// --------------------------------------------------------------------- 
// metodi comuni a tutti i controllori di finestra del documento
// aggiornamento del contenuto della finestra
- (void) 
refreshWindow 
{
	[ volList reloadData ];
	if ( [ cvrView catView] )
		[ [ cvrView catView] reloadData ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// impostazione della barra di stato
- (void) 
setStsStrings: (NSString *) sts1Val 
	andSts: (NSString *) st2Val;
{
	// per ora faccio nulla
	return ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// vista principale della finestra
- (NSTableView*) 
getMainView 
{
	return ( volList );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (BOOL)windowShouldClose:(id)sender
 {
	[ [ self document ] setCoverWin: nil ] ;
	return ( YES );
 }
 
// --------------------------------------------------------------------- 
// accessor
- (CoverView *)cvrView {
    return cvrView ;
}

- (void)setCvrView:(CoverView *)newCvrView {
    if (cvrView != newCvrView) {
        [cvrView release];
        cvrView = [newCvrView retain];
    }
}


@end

NSString*
displayZoomFactor( float zf )
{

	if ( zf < 1 )
	{
		return ( [NSString stringWithFormat: @"x1/%2.1f", (1/zf) ] );
	}
	return ([NSString stringWithFormat: @"x%2.1f", zf ] );
}
