// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  FileStruct.h
//  Created by djzero00 
//  No Copyright 2004
//
// Interfaccia della classe che modella le informazioni gerarchiche

#import <Cocoa/Cocoa.h>
// questa e' una sottoclasse di CatFileInfo
#import "CatFileInfo.h"

@interface FileStruct : CatFileInfo {
	// se e' una directory, i file contenuti
	NSMutableArray  * fileList ;
	// criterio e direzione di ordine
	NSString		* orderColumn ;
	BOOL			orderDirection ;
}

// solito inizializzatore e deallocatore
- (id)	 initTreeFromPath: (NSString*) fullPath ;
- (void) dealloc ;

// per accedere ad un elemento nella directory
- (FileStruct *) getFileAtIndex: (int) elem ;
// numero di elementi presenti all'interno di una directory
- (int) numOfFiles ;

// lettura/scrittura
- (void)encodeWithCoder:(NSCoder *)encoder ;
- (id)initWithCoder:(NSCoder *)decoder ;

// ordinamento
- (void) sortFileList: (NSString*) type direction: (BOOL) dir ;

// metodi accessor
- (NSMutableArray *)fileList;
- (void)setFileList:(NSMutableArray *)newFileList;
- (NSString *)orderColumn;
- (void)setOrderColumn:(NSString *)newOrderColumn;
- (BOOL)orderDirection;
- (void)setOrderDirection:(BOOL)newOrderDirection;

- (void) searchItemFor: (id) item2search column: (NSString*) colId options: (int) opt placeIn: (NSMutableArray*) foundItems ;
- (void) expandFStoItem: (NSEnumerator*) enumer inOutlineView: (NSOutlineView *) outView ;

@end
