// ObjMakerWinCtl.m
// Sketch Example
//

#import "ObjMakerWinCtl.h"

#import "CoverWinCtl.h"
#import "CoverView.h"

@implementation ObjMakerWinCtl

// --------------------------------------------------------------------- 
+ (id)sharedObjMakerWinCtl 
{
	static	ObjMakerWinCtl	* locSharedWinCtrl  = nil ;
	
	if ( ! locSharedWinCtrl )
	{
		locSharedWinCtrl = [[ ObjMakerWinCtl allocWithZone: [self zone]] init ] ;
	}
	return ( locSharedWinCtrl );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (id)init {
	self = [ self initWithWindowNibName: @"ObjMakerWin" ];
	theDrawView = nil;
	return ( self );
}

// --------------------------------------------------------------------- 
- (void)windowDidLoad 
{
    [super windowDidLoad];
    [fillCheckbox setState:NSOffState];
    [fillCheckbox setEnabled:YES];
    [fillColorWell setColor:[NSColor whiteColor]];
    [fillColorWell setEnabled:YES];
    [lineCheckbox setState:NSOnState];
    [lineCheckbox setEnabled:YES];
    [lineColorWell setColor:[NSColor blackColor]];
    [lineColorWell setEnabled:YES];
    [lineWidthSlider setFloatValue:0.0];
    [lineWidthSlider setEnabled:YES];
    [lineWidthTextField setFloatValue:0.0];
    [lineWidthTextField setEnabled:YES];
    [xTextField setStringValue:@""];
    [xTextField setEnabled:YES];
    [yTextField setStringValue:@""];
    [yTextField setEnabled:YES];
    [widthTextField setStringValue:@""];
    [widthTextField setEnabled:YES];
    [heightTextField setStringValue:@""];
    [heightTextField setEnabled:YES];
	// aggiungo due osservatori quando cambia la finestra principale
	// in modo che possa aggiustare theDrawView
    [[NSNotificationCenter defaultCenter] addObserver:self 
		selector:@selector(mainWindowChanged:) 
		name:NSWindowDidBecomeMainNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self 
		selector:@selector(mainWindowResigned:) 
		name:NSWindowDidResignMainNotification object:nil];
	// pero' devo mettere a posto la prima volta 
	// recupero la finestra di fronte a tutti
	[self setMainWindow:[NSApp mainWindow]];
}

// --------------------------------------------------------------------- 
- (void)
mainWindowChanged: (NSNotification *)notification 
{
    [self setMainWindow:[notification object]];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
mainWindowResigned: (NSNotification *)notification 
{
    [self setMainWindow:nil];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
setMainWindow: (NSWindow *) mainWindow 
{
    NSWindowController *controller = [mainWindow windowController];
	// se c'e' una finestra ed e' del tipo giusto
    if (controller && [controller isKindOfClass:[CoverWinCtl class]]) 
	{
		theDrawView = [(CoverWinCtl *)controller cvrView];
		[ createButton setEnabled:YES];
	}
	else	
	{
		theDrawView = nil;
		[ createButton setEnabled:NO];
	}
	// qui dovrei aggiornare la finestra, se il caso
	// [self updateMe];
}

// --------------------------------------------------------------------- 
- (IBAction)createObject:(id)sender
{

	if ( theDrawView == nil )
	{
		NSBeep( );
		return ;
	}
	// se arrivo qui, ho un posto dove disegnare
	switch ( [[ classSelection selectedItem] tag ] ) {
	case 10 :   // disegno una linea
		{
			float			x1, y1, x2, y2 ;
			CCE_Line		* tmpLine ;

			// recupero le informazioni di colore
			x1 = [ xTextField floatValue ] ;
			y1 = [ yTextField floatValue ] ;
			x2 = [ widthTextField floatValue ] ;
			y2 = [ heightTextField floatValue ] ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
							toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ lineColorWell color] ];
			[ tmpLine setCceLineWidth: [ lineWidthTextField floatValue ] ];
			// recupero la vista
			[ [theDrawView theElements]  addElem: tmpLine ]; 
			[theDrawView setNeedsDisplayInRect: [theDrawView bounds] ];		
		}
		break ;
	case 11 :   // disegno un rettangolo
		{
			float			x1, y1, x2, y2 ;
			CCE_Rect		* tmpRect ;

			// recupero le informazioni di colore
			x1 = [ xTextField floatValue ] ;
			y1 = [ yTextField floatValue ] ;
			x2 = [ widthTextField floatValue ] ;
			y2 = [ heightTextField floatValue ] ;	
			tmpRect = [ [ CCE_Rect alloc] initWithRect: 
				NSMakeRect( CM2PX(x1), CM2PX(y1), CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpRect setCceLineColor: [ lineColorWell color] ];
			[ tmpRect setCceFillColor: [ fillColorWell color] ];
			[ tmpRect setCceIsFilled: [fillCheckbox state ] ];			
			[ tmpRect setCceIsStroked: [lineCheckbox state ] ];			
			[ tmpRect setCceLineWidth: [ lineWidthTextField floatValue ] ];

			[ [theDrawView theElements]  addElem: tmpRect ]; 
			[theDrawView setNeedsDisplayInRect: [theDrawView bounds] ];		
		}
		break ;
	case 12 :   // disegno un cerchio
		{
			float			x1, y1, x2, y2 ;
			CCE_Circle		* tmpRect ;

			// recupero le informazioni di colore
			x1 = [ xTextField floatValue ] ;
			y1 = [ yTextField floatValue ] ;
			x2 = [ widthTextField floatValue ] ;
			y2 = [ heightTextField floatValue ] ;	
			tmpRect = [ [ CCE_Circle alloc] initWithRect: 
				NSMakeRect( CM2PX(x1), CM2PX(y1), CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpRect setCceLineColor: [ lineColorWell color] ];
			[ tmpRect setCceFillColor: [ fillColorWell color] ];
			[ tmpRect setCceIsFilled: [fillCheckbox state ] ];			
			[ tmpRect setCceIsStroked: [lineCheckbox state ] ];			
			[ tmpRect setCceLineWidth: [ lineWidthTextField floatValue ] ];

			[ [theDrawView theElements]  addElem: tmpRect ]; 
			[theDrawView setNeedsDisplayInRect: [theDrawView bounds] ];		
		}
		break ;
	default :
		break ;
	}
}
@end
