// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  WaitPanCtrl.m
//  Created by djzero00 -- Copyright (c) 2002
//
// Finestra di lavori in corso

#import "WaitPanCtrl.h"

@implementation WaitPanCtrl

// --------------------------------------------------------------------- 
// imposto il testo presente all'interno della finestra
+ (void) setText: (NSString*) title
{
	// chiamo un metodo interno
	[ [ WaitPanCtrl sharedProgress] setMainText: title ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
+ (void) setModalSession: (NSModalSession*) newSession 
{
	[ [ WaitPanCtrl sharedProgress] localSetModalSession: newSession ];
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// mostro/nascondo la finestra 
+ (void) showHide: (BOOL) state
{
	// mostro/nascondo direttamente la fienstra
	[[[ WaitPanCtrl sharedProgress] window] setIsVisible: state ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
+ (void) setMaxValue: (double) maxval
{
	[ [ WaitPanCtrl sharedProgress] localSetMaxValue: maxval ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
+ (void) setCurrentValue: (double) currval
{
	[ [ WaitPanCtrl sharedProgress] localSetDoubleValue: currval ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
+ (double) getCurrentValue
{
	return( [[ WaitPanCtrl sharedProgress] localDoubleValue] );
}

// --------------------------------------------------------------------- 
// istanza condivisa (e sua inizializzazione, se necessario) della finestra
+ (id) sharedProgress
{
	static WaitPanCtrl * _sharedProgress = nil ;

	if ( ! _sharedProgress )
	{
		_sharedProgress = [ [WaitPanCtrl alloc] init ];
	}
	
	return ( _sharedProgress );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// inizializzazione, carico il giusto nib
- (id )
init 
{
	self = [ self initWithWindowNibName: @"waitingPanel" ];
	maxValue = 1 ;
	currValue = 0 ;
	session = nil ;
	return ( self );
}

// non mi preoccupo di un dealloc, perche' la finestra e' unica e creata
// una sola volta; morira' alla fine dei tempi

// --------------------------------------------------------------------- 
// per impostare il testo della finestra
- (void ) 
setMainText: (NSString*) title
{
	// banale, imposto la stringa
	[ infoText setStringValue: title ] ;
	// forzo il rinfresco della finestra
	[ infoText displayIfNeeded ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void) localSetMaxValue: (double) maxval
{
	[ progressBar setMaxValue: maxval ];
	maxValue = maxval ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void) localSetDoubleValue: (double) currval
{
	if ( session != nil )
		[NSApp runModalSession: *session] ;
	[ progressBar setDoubleValue: currval ];
	currValue = currval ;
	[ progressBar displayIfNeeded ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void) 
localSetModalSession: (NSModalSession*) newSession
{
	session = newSession ; 
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (double) localDoubleValue
{
	return( currValue );
}

@end
