// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  djZeroUtils.m
//  Created by djzero00 - - Copyright (c) 2002
//
// utilities di vario genere per il mio uso e consumo

#import		"djZeroUtils.h"

#import		"FileStruct.h"

int	lsSortFunction( id el1, id el2, void * ctx );

// --------------------------------------------------------------------- 
// di una NSImage, sceglie la rappresentazione piu' piccola, 
// poi scala tutto a 16x16
NSImage *
reduceImageToIcon( NSImage * img )
{
	NSImage		* reducedImg ;
	NSSize		smallIconSize ;
	int		minSize, minImgIndex;
	unsigned int	i ;
	NSImageRep 	* imageRep ;
	// recupero la lista delle rappresentazioni
	NSArray		* tmp = [ img representations ] ;
	// potrebbe non esserci l'immagine
	if ( [ tmp count ] == 0 )
		return ( nil) ;
	// per ora la rappresentazione minima e' la prima
	minImgIndex = 0 ;
	imageRep = [ tmp objectAtIndex: minImgIndex ];
	minSize = [ imageRep pixelsHigh ];
	// poi guardo tutte le altre rappresentazioni
	for ( i = 1 ; i < [ tmp count ] ; i ++ )
	{
		int		hh ;
		imageRep = [ tmp objectAtIndex: i ];
		// se la dimensione della rappresentazione corrente...
		hh = [ imageRep pixelsHigh ];
		// ...e' maggiore
		if ( hh < minSize )
		{
			// ho trovato una nuova rappresentazione minima
			// me la segno
			minImgIndex = i ;
			minSize = hh ;
		}
	}
	reducedImg = [ [ [NSImage alloc] init ] autorelease ];
	// arrivato qui, ho trovato al rappresentazione piu' piccola
	[ reducedImg addRepresentation: [ tmp objectAtIndex: minImgIndex ]];
	// dico di scalarla quando sara' ridimensionata
	[ reducedImg setScalesWhenResized: TRUE ];
	// perche' adesso la ridimensiono a 16x16
	smallIconSize.width = smallIconSize.height = 16 ;
	// ecco che la ridimensiono
	[ reducedImg setSize: smallIconSize];
	return (reducedImg);
}

// --------------------------------------------------------------------- 
// funzioni per la gestioen dell'ordinamento

int
ascSortFunc( id el1, id el2, void * ctx )
{	
	return ( lsSortFunction( el1, el2, ctx ));
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int
desSortFunc( id el1, id el2, void * ctx )
{	
	return ( lsSortFunction( el2, el1, ctx ));
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int
lsSortFunction( id el1, id el2, void * ctx )
{
	id	s1, s2 ;
	// il confronto sulla dimensione del file (sempre per il solito misterioso
	// motivo i long long non funzionano con valueForKey 
	if ( [ (NSString*)ctx isEqual: COLID_FILESIZE ] )
	{
		// ricavo le due dimensioni
		long long	tmp1 = [ (CatFileInfo*)el1 fileSize ] ;
		long long	tmp2 = [ (CatFileInfo*)el2 fileSize ] ;
		// e le confronto brutalmente; notare i valori di ritorno
		if (tmp1 < tmp2)
			return NSOrderedAscending;
		else if (tmp1 > tmp2)
			return NSOrderedDescending;
		return NSOrderedSame;
	}
	// per tutte le altre colonne, uso il polimorfismo (late binding)
	// ricavo i due elementi, non meglio specificando la natura
	// possono essere stringhe, numeri o da te
	s1 = [ (CatFileInfo*)el1 valueForKey: ctx ];
	s2 = [ (CatFileInfo*)el2 valueForKey: ctx ];
	// pero' tutti e tre i tipi rispondono al messaggio compare:
	// e quindi, l'istruzione seguente chiama il metodo appropriato
	return ( [ s1 compare: s2]);
	// con questa versione del codice, il compilatore mi da un po' 
	// di warning, proprio su questa istruzione...
}
